﻿local hmdAddonData, PrivateTable = ...

local hmd = {
	version = hmdAddonData.toc.Version,
	params = nil,
	indy = false,
	name = nil,
	sTrack = false,
	rTrack = false,
}

function hmd.trackSenderStatusLookup()
	local playerName = Inspect.Unit.Detail("player").name 
	for name, trackStatus in pairs(Indy.trackCollectionsForChars) do
		if (playerName == name) and (trackStatus) then
			hmd.name = name
			hmd.sTrack = true
		end
	end
end

function hmd.trackRcptStatusLookup()
	for name, trackStatus in pairs(Indy.trackCollectionsForChars) do
		if (hmd.params == name) and trackStatus then
			hmd.rTrack = true
		end		
	end
end

function hmd.FindArtifactSetsContainingId(id)
    local sets = {}
    local setCount = 0
    for setName, ids in pairs(INDY_ArtifactCollections) do
        if ids[id] then
            sets[setName] = true
            setCount = setCount + 1
        end
    end
    return sets, setCount
end

function hmd.BuildIndyArtTable(name)
	local ToA = {}
	local ac = 0
	local playerName = Inspect.Unit.Detail("player").name 
	
	for x = 1, 7, 1 do
		for y = 1, 32, 1 do
			local item = Inspect.Item.Detail(Utility.Item.Slot.Inventory(x,y))
			if item ~= nil then
				if string.find (item.category, "artifact") ~= nil then
					if Indy.artifactTable[item.type] then
						local _, setCount = hmd.FindArtifactSetsContainingId(item.type)
						local statusCollected = Indy.artifactTable[item.type][name]
						if name == playerName then
							if (statusCollected == setCount) then
								ac = ac + 1
								table.insert(ToA, ac, item.id)
							end
						else
							if (statusCollected ~= setCount) then
								ac = ac + 1
								table.insert(ToA, ac, item.id)
							end
						end
					end
				end
			end
		end
	end
	return ToA
end	

function hmd.CountArtifacts()
	local ac = 0
	for x = 1, 7, 1 do
		for y = 1, 32, 1 do
			local item = Inspect.Item.Detail(Utility.Item.Slot.Inventory(x,y))
			if item ~= nil then
				if string.find (item.category, "artifact") ~= nil then
					ac = ac + 1
				end
			end
		end
	end
	return ac
end

function hmd.BuildAllArtTable()
	local ToA = {}
	local ac = 0

	for x = 1, 7, 1 do
		for y = 1, 32, 1 do
			local item = Inspect.Item.Detail(Utility.Item.Slot.Inventory(x,y))
			if item ~= nil then
				if string.find (item.category, "artifact") ~= nil then
					ac = ac + 1
					table.insert(ToA, ac, item.id)
				end
			end
		end
	end
	return ToA
end

function hmd.SendArtifacts(params)
--[[local infoCtxt = UI.CreateContext("InfoFrm")
	local frmInfo = UI.CreateFrame("Frame", "SendInfo", infoCtxt)
	local infoTxt = UI.CreateFrame("Text", "InfoText", frmInfo)
	
	hmd.okwindow:SetVisible(false)
	
	frmInfo:SetWidth(200)
	frmInfo:SetHeight(100)
	frmInfo:SetBackgroundColor(0,0,0,255)
	frmInfo:SetPoint("CENTER", UIParent, "CENTER")
	frmInfo:SetLayer(100)
	frmInfo:SetAlpha(0.8)
	
	infoTxt:SetPoint("TOPCENTER", frmInfo, "TOPCENTER", 25, 0)
	]]
	
	local mail = {}
	local attachment = {}
	local actotal = 0
	
	if hmd.indy and hmd.checkAll ~= nil and hmd.checkAll:GetChecked() then
		attachment = hmd.BuildIndyArtTable(hmd.name)
	elseif hmd.indy and hmd.checkRecptAll ~= nil and hmd.checkRecptAll:GetChecked() then
		attachment = hmd.BuildIndyArtTable(hmd.params)
	else
		attachment = hmd.BuildAllArtTable()
	end
	
	actotal = table.getn(attachment)
	
	if actotal <= 6  and actotal >= 1 then
		mail = {to = hmd.params, subject = "Arties", attachments = attachment}
		if (Inspect.Interaction("mail")) then
			Command.Mail.Send(mail)
			print("Everything sent.")
		end
		hmd.okwindow:SetVisible(false)
	elseif actotal >= 6 then
		local artPart = {}
		for x = 1, 6, 1 do
			table.insert(artPart, x, attachment[x])
		end
		mail = {to = hmd.params, subject = "Arties", attachments = artPart}
		artPart = {}
		if (Inspect.Interaction("mail")) then
			Command.Mail.Send(mail)
		end
		
	elseif actotal == 0 then
		print("Everything sent.")
		hmd.okwindow:SetVisible(false)
		hmd.params = nil
	end
end

function hmd.Construct()
	hmd.context = UI.CreateContext("hmdok")
	hmd.okwindow = UI.CreateFrame("Frame", "OkWindow", hmd.context)
	hmd.runButton = UI.CreateFrame("RiftButton", "SendButton", hmd.okwindow)
	hmd.stopButton = UI.CreateFrame("RiftButton", "CancelButton", hmd.okwindow)
	hmd.inputField = UI.CreateFrame("Text", "ConfirmationText", hmd.okwindow)
	
	hmd.okwindow:SetWidth(300)
	hmd.okwindow:SetHeight(100)
	hmd.okwindow:SetBackgroundColor(0,0,0,255)
	hmd.okwindow:SetPoint("CENTER", UIParent, "CENTER")
	hmd.okwindow:SetLayer(50)
	hmd.okwindow:SetAlpha(0.8)

	hmd.inputField:SetPoint("TOPCENTER", hmd.okwindow, "TOPCENTER", 25,0)
	hmd.inputField:SetBackgroundColor(0,0,0,0)
	hmd.inputField:SetWidth(250)
	hmd.inputField:SetHeight(50)
	hmd.inputField:SetFontSize(20)
	hmd.inputField:SetWordwrap(true)
	
	if hmd.indy then
		if hmd.sTrack then
			hmd.checkAll = UI.CreateFrame("RiftCheckbox", "SendAll", hmd.okwindow)
			hmd.checkAll:SetPoint("TOPLEFT", hmd.okwindow, "TOPLEFT", 10, 50)
			
			hmd.checkAllLabel = UI.CreateFrame("Text", "SendAllLabel", hmd.okwindow)
			hmd.checkAllLabel:SetPoint("LEFTCENTER", hmd.checkAll, "RIGHTCENTER", 4, 0)
		end
		if hmd.rTrack and hmd.sTrack then
			hmd.okwindow:SetHeight(150)
			hmd.checkRecptAll = UI.CreateFrame("RiftCheckbox", "RcptNeeds", hmd.okwindow)
			hmd.checkRecptAll:SetPoint("TOPCENTER", hmd.checkAll, "BOTTOMCENTER", 0, 4)		
			
			hmd.checkRecptLabel = UI.CreateFrame("Text", "RcptNeedsLabel", hmd.okwindow)
			hmd.checkRecptLabel:SetPoint("LEFTCENTER", hmd.checkRecptAll, "RIGHTCENTER", 4, 0)
		elseif hmd.rTrack and not hmd.sTrack then
			hmd.checkRecptAll = UI.CreateFrame("RiftCheckbox", "RcptNeeds", hmd.okwindow)
			hmd.checkRecptAll:SetPoint("LEFTCENTER", hmd.okwindow, "LEFTCENTER")		
			
			hmd.checkRecptLabel = UI.CreateFrame("Text", "RcptNeedsLabel", hmd.okwindow)
			hmd.checkRecptLabel:SetPoint("LEFTCENTER", hmd.checkRecptAll, "RIGHTCENTER", 4, 0)
		end
	end

	hmd.runButton:SetWidth(100)
	hmd.runButton:SetPoint("BOTTOMCENTER", hmd.okwindow, "BOTTOMCENTER", -50, -10)
	hmd.runButton:EventAttach(Event.UI.Input.Mouse.Left.Click, hmd.SendArtifacts, "SendArtifacts")

	hmd.stopButton:SetWidth(100)
	hmd.stopButton:SetPoint("BOTTOMCENTER", hmd.okwindow, "BOTTOMCENTER", 50, -10)
	hmd.stopButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function() hmd.okwindow:SetVisible(false) end, "HideWindow")
end

function hmd.Populate(params)
	hmd.runButton:SetText("Send")
	hmd.inputField:SetText("Send arties to "..params.."?")
	if hmd.checkAllLabel ~= nil then hmd.checkAllLabel:SetText("Send only non-collected artifacts?") end
	if hmd.checkRecptLabel ~= nil then hmd.checkRecptLabel:SetText("Send only artifacts the recipient needs?") end
	hmd.stopButton:SetText("Cancel")
	hmd.okwindow:SetVisible(true)
end

function hmd.SlashHandler(h, args)
	hmd.params=args
	if hmd.params == nil and CountArtifacts() > 0 then
		print("...")
		print("Usage: /hmd <toon-name-to-mail-arties-to>")
	elseif hmd.CountArtifacts() > 0 then
		if hmd.indy then
			hmd.trackSenderStatusLookup()
			hmd.trackRcptStatusLookup()
		end
		if hmd.okwindow == nil then
			hmd.Construct()
		end
		hmd.Populate(hmd.params)
	end
end

--[[ function hmd.loadEnd()
	hmd.printVersion()
end ]]--

function hmd.startupEnd()
	if Indy_SavedVariables then
		print("HandMeDowns version " .. hmd.version .. " with Indy support loaded!")
		hmd.indy = true
	else
		print("HandMeDowns version " .. hmd.version .. " loaded!")
	end
end

--[[ function hmd.printVersion()
	print("HandMeDowns version " .. hmd.version .. " installed!")
end ]]--

Command.Event.Attach(Command.Slash.Register("hmd"), hmd.SlashHandler, "SlashHandler")
Command.Event.Attach(Event.Addon.Startup.End, hmd.startupEnd, "StartupFinished")
--Command.Event.Attach(Event.Addon.Load.End, hmd.loadEnd, "AddonLoaded")